package request

import (
	pb "sghgogs.com/sghblog/authorization-service/proto"
	"time"
)

type AdminRole struct {
	ID          int64             `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name        string            `json:"name"`
	Description string            `json:"description"`
	Users       []AdminUser       `gorm:"many2many:admin_user_role;" json:"users"`
	Permissions []AdminPermission `gorm:"many2many:admin_role_permission;" json:"permissions"`
	CreatedBy   string            `json:"created_by"`
	OperatorID  int64             `json:"operator_id"`
	CreatedAt   time.Time         `json:"created_at"`
	UpdatedAt   *time.Time        `json:"updated_at"`
	Status      pb.StatusEnum     `json:"status"` // 可以是 "enabled", "disabled", "deleted" 等
	IsReserved  bool              `json:"is_reserved"`
}

// func (u *AdminUser) BeforeUpdate(tx *gorm.DB) (err error) {
// 	fmt.Print("BeforeCreate......")
// 	return
// }
//
// // AfterUpdate 在同一个事务中更新数据
// func (u *AdminUser) AfterUpdate(tx *gorm.DB) (err error) {
// 	fmt.Print("AfterUpdate......")
// 	return
// }
