package request

// AdminTeam 直接将用户添加到团队的 Members 中
// db.Model(&team).Update("Members", gorm.Expr("ARRAY_APPEND(members, ?)", userID))
// 假设 teamID 为团队的 ID
// var team Team
// if err := db.Preload("Members").First(&team, teamID).Error; err != nil {
// // 处理团队不存在的情况
// }
type AdminTeam struct {
	ID          int64             `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name        string            `json:"name"`        // 团队名称
	Description string            `json:"description"` // 团队描述
	LeaderID    int64             `json:"leader_id"`   // 团队领导的用户 ID
	CreatedBy   string            `json:"created_by"`  // 创建团队的用户
	CreateTime  int64             `json:"create_time"` // 团队创建时间
	Leader      AdminUser         `gorm:"foreignkey:LeaderID" json:"leader"`
	Members     []AdminUser       `gorm:"many2many:admin_team_member;" json:"members"`
	Roles       []AdminRole       `gorm:"many2many:admin_team_role;" json:"roles"`
	Permissions []AdminPermission `gorm:"many2many:admin_team_permission;" json:"permissions"`
	Website     string            `json:"website"`     // 团队网站
	MaxMembers  int               `json:"max_members"` // 团队最大成员数
}
