package request

import "time"

type AuditLog struct {
	ID             int64     `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	UserID         int64     `gorm:"index"`
	Action         string    `json:"action"`          // 操作类型，可以是 "create", "update", "delete" 等
	TableName      string    `json:"table_name"`      // 操作的表名
	RecordID       int64     `json:"record_id"`       // 操作的记录ID
	OldData        string    `json:"old_data"`        // 操作前的数据状态
	NewData        string    `json:"new_data"`        // 操作后的数据状态
	IPAddress      string    `json:"ip_address"`      // 操作者的IP地址
	UserAgent      string    `json:"user_agent"`      // 操作者的User-Agent信息
	AdditionalInfo string    `json:"additional_info"` // 额外的信息
	CreatedAt      time.Time `json:"created_at"`
}
